Subject: [bug#46806] [PATCH] gnu: ocaml-4.07: Bootstrap.

From: Julien Lepiller <[email-masked]>
Date: Wed, 03 Mar 2021 08:46:08 -0500

We'd have to check we actually can build them. The plan was to build menhir with this ocaml4.07, since it's required to generate the parser for ocaml >= 4.08, and improve camlboot to support more recent versions. We would prevent the need for a chain of bootstraps that way.

Anyway, I'll push that after fixing your comments, and we'll see what we can do for the following ocaml versions. Thanks for the review!

I don't think ocaml has so many dependants that it requires core-updates. Not even sure it needs staging.

Le 3 mars 2021 08:27:54 GMT-05:00, zimoun <[email-masked]> a écrit :
>Hi Julien,
>
>On Sat, 27 Feb 2021 at 00:13, Julien Lepiller <[email-masked]>
>wrote:
>
>> The first patch builds the bootstraped ocamlc and ocamllex. This
>takes
>> around 4 hours to build. The second patch rebuilds them using the
>source
>> code for ocaml 4.07.1, instead of the modified sources used in
>> camlboot, and reuse them to run the main Makefile (make world.opt).
>
>On my machine, camlboot takes ~3h to build.  Then ocaml-4.07-boot takes
>~30s.  Last there is no meaningful difference between building
>ocaml-4.07 using the embedded ocamlc and ocamlex binaries and using the
>binaries from ocaml-4.04-boot; both ~6m.
>
>I have check that camlboot, ocaml-4.07-boot and ocaml-4.07 build
>reproducibly with ’--check’.  They do.
>
>
>> As a result, we have identical files for this bootstrap and the
>> unbootstrapped OCaml (up to output store paths and hash of some files
>> that get embedded in native files, which differ because of the
>> different output path).
>
>At first look, yes. :-)
>
>
>Modulo the minor comments I made, patches LGTM!  Thanks.
>
>
>Well, the next steps are to build ocaml-4.09 and ocaml-4.11 using the
>previous ocamlc and ocamlex version, right?
>
>Then, it implies rebuild all the OCaml packages, right?  It could be
>done in this core-updates cycle, WDYT?
>
>Cheers,
>simon